#pragma once
#define SCPECG_API __declspec(dllimport)

#pragma comment(lib, "scpecg.lib")

#define SCPREC void*

#pragma pack(push, 1)

#define SCP_UNITS_AGE_UNDEFINED		0
#define SCP_UNITS_AGE_YEARS			1
#define SCP_UNITS_AGE_MONTHS		2
#define SCP_UNITS_AGE_WEEKS			3
#define SCP_UNITS_AGE_DAYS			4
#define SCP_UNITS_AGE_HOURS			5

#define SCP_UNITS_HEIGHT_UNDEFINED	0
#define SCP_UNITS_HEIGHT_CM			1
#define SCP_UNITS_HEIGHT_INCHES		2
#define SCP_UNITS_HEIGHT_MM			3

#define SCP_UNITS_WEIGHT_UNDEFINED	0
#define SCP_UNITS_WEIGHT_KG			1
#define SCP_UNITS_WEIGHT_GRAMS		2
#define SCP_UNITS_WEIGHT_POUNDS		3
#define SCP_UNITS_WEIGHT_OUNCES		4

#define SCP_UNITS_SEX_UNKNOWN		0
#define SCP_UNITS_SEX_MALE			1
#define SCP_UNITS_SEX_FEMALE		2
#define SCP_UNITS_SEX_UNDEFINED		9

#define SCP_UNITS_RACE_UNDEFINED	0
#define SCP_UNITS_RACE_CAUCASIAN	1
#define SCP_UNITS_RACE_BLACK		2
#define SCP_UNITS_RACE_ORIENTAL		3

#define SCP_DEVTYPE_HOST			0
#define SCP_DEVTYPE_CART			1


//  ( 14)
struct SCP_DEVICEID
{
	int instNum;		// 
	int depNum; 		// 
	int devId; 		//id 
	int devType; 		//  (0 - host, 1 - cart)
	int manufCode;  	//  (   255)
	TCHAR *model; 		//  (  )
	bool canPrint;  	//  
	bool canAcquire; 	//  
	bool canStore;		//  
	bool canAnalyze;	//  
	int acMains;		//    
				//(   50  60 )
	TCHAR *analysingProgramVersion;	//  
	TCHAR *serialNumber; 		//  
	TCHAR *systemSoftware; 		// 
	TCHAR *scpImplementSoftware;	//    SCP
	TCHAR *tradeName;		//
};


SCPECG_API SCPREC SCPRecordCreate();
SCPECG_API void SCPRecordDestroy(SCPREC rec);

SCPECG_API wchar_t *SCPGetDebugLog(SCPREC rec);

SCPECG_API bool SCPReadFromFile(SCPREC rec, wchar_t *fileName);
SCPECG_API void SCPInitWrite(SCPREC rec, int codepage);
SCPECG_API bool SCPWriteToFile(SCPREC rec, wchar_t *fileName);

SCPECG_API void SCPSetSampleRate(SCPREC rec, int _sampleRate);
SCPECG_API int SCPGetSampleRate(SCPREC rec);
SCPECG_API void SCPSetAMV(SCPREC rec, unsigned short _amv);
SCPECG_API unsigned short SCPGetAMV(SCPREC rec);
SCPECG_API char SCPGetNumberOfLeads(SCPREC rec);
SCPECG_API bool SCPGetLeadInfo(SCPREC rec, int id, unsigned char *leadCode,
							unsigned int *nSamples);

SCPECG_API wchar_t *SCPGetLeadNameByCode(unsigned char leadCode);
SCPECG_API unsigned char SCPGetLeadCodeByName(wchar_t *name);

SCPECG_API bool SCPGetLeadData(SCPREC rec, int id, short *samples);
SCPECG_API bool SCPAddLead(SCPREC rec, unsigned char leadCode,
						unsigned int startTimeSample, 
						unsigned int endTimeSample, 
						short *samples);
SCPECG_API void SCPSetCompression(SCPREC rec, bool cHuffman,
								bool cDefaultHuffmanTable, 
								int cDifference,
								bool cRefBeatSubtraction);
SCPECG_API wchar_t *SCPGetLastName(SCPREC rec);
SCPECG_API void SCPSetLastName(SCPREC rec, wchar_t *lastName);
SCPECG_API wchar_t *SCPGetFirstName(SCPREC rec);
SCPECG_API void SCPSetFirstName(SCPREC rec, wchar_t *firstName);
SCPECG_API wchar_t *SCPGetPatientID(SCPREC rec);
SCPECG_API void SCPSetPatientID(SCPREC rec, wchar_t *patientId);
SCPECG_API wchar_t *SCPGetSecondLastName(SCPREC rec);
SCPECG_API void SCPSetSecondLastName(SCPREC rec, wchar_t *secondLastName);
SCPECG_API int SCPGetAge(SCPREC rec, int *units);
SCPECG_API void SCPSetAge(SCPREC rec, int age, int units);
SCPECG_API void SCPGetDateOfBirth(SCPREC rec, int *year, int *month, int *day);
SCPECG_API void SCPSetDateOfBirth(SCPREC rec, int year, int month, int day);
SCPECG_API int SCPGetHeight(SCPREC rec, int *units);
SCPECG_API void SCPSetHeight(SCPREC rec, int height, int units);
SCPECG_API int SCPGetWeight(SCPREC rec, int *units);
SCPECG_API void SCPSetWeight(SCPREC rec, int weight, int units);
SCPECG_API int SCPGetSex(SCPREC rec);
SCPECG_API void SCPSetSex(SCPREC rec, int sex);
SCPECG_API int SCPGetRace(SCPREC rec);
SCPECG_API void SCPSetRace(SCPREC rec, int race);
SCPECG_API int SCPGetSystolicBloodPressure(SCPREC rec);
SCPECG_API void SCPSetSystolicBloodPressure(SCPREC rec, int pr);
SCPECG_API int SCPGetDiastolicBloodPressure(SCPREC rec);
SCPECG_API void SCPSetDiastolicBloodPressure(SCPREC rec, int pr);
SCPECG_API wchar_t *SCPGetDiagnosis(SCPREC rec);
SCPECG_API void SCPSetDiagnosis(SCPREC rec, wchar_t *diagnosis);
SCPECG_API void SCPSetAcqDeviceID(SCPREC rec, SCP_DEVICEID *devId);
SCPECG_API void SCPGetAcqDeviceID(SCPREC rec, SCP_DEVICEID *devId);
SCPECG_API wchar_t *SCPGetAcqInstDescr(SCPREC rec);
SCPECG_API void SCPSetAcqInstDescr(SCPREC rec, wchar_t *descr);
SCPECG_API wchar_t *SCPGetAnalyzingInstDescr(SCPREC rec);
SCPECG_API void SCPSetAnalyzingInstDescr(SCPREC rec, wchar_t *descr);
SCPECG_API wchar_t *SCPGetAcqDepDescr(SCPREC rec);
SCPECG_API void SCPSetAcqDepDescr(SCPREC rec, wchar_t *descr);
SCPECG_API wchar_t *SCPGetAnalyzingDepDescr(SCPREC rec);
SCPECG_API void SCPSetAnalyzingDepDescr(SCPREC rec, wchar_t *descr);
SCPECG_API wchar_t *SCPGetReferringPhysician(SCPREC rec);
SCPECG_API void SCPSetReferringPhysician(SCPREC rec, wchar_t *refPh);
SCPECG_API wchar_t *SCPGetLatestConfirmingPhysician(SCPREC rec);
SCPECG_API void SCPSetLatestConfirmingPhysician(SCPREC rec, wchar_t *confPh);
SCPECG_API wchar_t *SCPGetTechnicianDescription(SCPREC rec);
SCPECG_API void SCPSetTechnicianDescription(SCPREC rec, wchar_t *techDescr);
SCPECG_API wchar_t *SCPGetRoomDescription(SCPREC rec);
SCPECG_API void SCPSetRoomDescription(SCPREC rec, wchar_t *roomDescr);
SCPECG_API void SCPGetAcqusitionDate(SCPREC rec, int *year, int *month, int *day);
SCPECG_API void SCPSetAcqusitionDate(SCPREC rec, int year, int month, int day);
SCPECG_API void SCPGetAcqusitionTime(SCPREC rec, int *hours, int *minutes, int *seconds);
SCPECG_API void SCPSetAcqusitionTime(SCPREC rec, int hours, int minutes, int seconds);
SCPECG_API wchar_t *SCPGetFreeTextField(SCPREC rec);
SCPECG_API void SCPSetFreeTextField(SCPREC rec, wchar_t *freeTextField);
SCPECG_API wchar_t *SCPGetFreeTextMedicalHistory(SCPREC rec);
SCPECG_API void SCPSetFreeTextMedicalHistory(SCPREC rec, wchar_t *freeTextField);
SCPECG_API void SCPFreeMem(void *ptr);
SCPECG_API void SCPSetCustomStringTag(SCPREC rec, unsigned char tag, TCHAR *str);
SCPECG_API void SCPSetCustomIntTag(SCPREC rec, unsigned char tag, int value);
SCPECG_API wchar_t *SCPGetCustomStringTag(SCPREC rec, unsigned char tag);
SCPECG_API int SCPGetCustomIntTag(SCPREC rec, unsigned char tag);


#pragma pack(pop)